diff --git a/pki/base/common/src/com/netscape/cmscore/connector/LocalConnector.java b/pki/base/common/src/com/netscape/cmscore/connector/LocalConnector.java
index 5898e3228308f534c8b67c258a66031f44a423fb..42c6636ce5fd4d40c950a8cd9ecdfe9625e23e2b 100644
--- a/pki/base/common/src/com/netscape/cmscore/connector/LocalConnector.java
+++ b/pki/base/common/src/com/netscape/cmscore/connector/LocalConnector.java
@@ -39,7 +39,7 @@ public class LocalConnector implements IConnector {
     ILogger mLogger = CMS.getLogger();
     ICertAuthority mSource = null;
     IAuthority mDest = null;
-    Hashtable mSourceReqs = new Hashtable();
+    Hashtable<String, IRequest> mSourceReqs = new Hashtable<String, IRequest>();
 
     public LocalConnector(ICertAuthority source, IAuthority dest) {
         mSource = source;
@@ -184,7 +184,7 @@ public class LocalConnector implements IConnector {
             // are persistent before the servicing.
             // Please see stateEngine() function in 
             // ARequestQueue.java for details.
-            r = (IRequest) mSourceReqs.get(rId);
+            r = mSourceReqs.get(rId);
             if (r != null) {
                 if (r.getRequestStatus() != RequestStatus.SVC_PENDING) {
                     mSource.log(ILogger.LL_FAILURE,
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/CRLIssuingPointRecord.java b/pki/base/common/src/com/netscape/cmscore/dbs/CRLIssuingPointRecord.java
index 9f0797d40d97856cb67bd7758e5a7a3ec7cc2311..0a3a46f141827ade45762f6e923426fb920a1659 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/CRLIssuingPointRecord.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/CRLIssuingPointRecord.java
@@ -23,6 +23,8 @@ import java.util.Enumeration;
 import java.util.Hashtable;
 import java.util.Vector;
 
+import netscape.security.x509.RevokedCertificate;
+
 import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.dbs.IDBObj;
@@ -51,10 +53,10 @@ public class CRLIssuingPointRecord implements ICRLIssuingPointRecord, IDBObj {
     protected String mFirstUnsaved = null;
     protected byte mCRL[] = null;
     protected byte mCACert[] = null;
-    protected Hashtable mCRLCache = null;
-    protected Hashtable mRevokedCerts = null;
-    protected Hashtable mUnrevokedCerts = null;
-    protected Hashtable mExpiredCerts = null;
+    protected Hashtable<BigInteger, RevokedCertificate> mCRLCache = null;
+    protected Hashtable<BigInteger, RevokedCertificate> mRevokedCerts = null;
+    protected Hashtable<BigInteger, RevokedCertificate> mUnrevokedCerts = null;
+    protected Hashtable<BigInteger, RevokedCertificate> mExpiredCerts = null;
     protected byte mDeltaCRL[] = null;
     protected static Vector<String> mNames = new Vector<String>();
     static {
@@ -106,7 +108,9 @@ public class CRLIssuingPointRecord implements ICRLIssuingPointRecord, IDBObj {
      */
     public CRLIssuingPointRecord(String id, BigInteger crlNumber, Long crlSize,
             Date thisUpdate, Date nextUpdate, BigInteger deltaCRLNumber, Long deltaCRLSize,
-            Hashtable revokedCerts, Hashtable unrevokedCerts, Hashtable expiredCerts) {
+            Hashtable<BigInteger, RevokedCertificate> revokedCerts,
+            Hashtable<BigInteger, RevokedCertificate> unrevokedCerts,
+            Hashtable<BigInteger, RevokedCertificate> expiredCerts) {
         mId = id;
         mCRLNumber = crlNumber;
         mCRLSize = crlSize;
@@ -121,6 +125,7 @@ public class CRLIssuingPointRecord implements ICRLIssuingPointRecord, IDBObj {
         mExpiredCerts = expiredCerts;
     }
 
+    @SuppressWarnings({ "unchecked" })
     public void set(String name, Object obj) throws EBaseException {
         if (name.equalsIgnoreCase(ATTR_ID)) {
             mId = (String) obj;
@@ -143,13 +148,13 @@ public class CRLIssuingPointRecord implements ICRLIssuingPointRecord, IDBObj {
         } else if (name.equalsIgnoreCase(ATTR_CA_CERT)) {
             mCACert = (byte[]) obj;
         } else if (name.equalsIgnoreCase(ATTR_CRL_CACHE)) {
-            mCRLCache = (Hashtable) obj;
+            mCRLCache = (Hashtable<BigInteger, RevokedCertificate>) obj;
         } else if (name.equalsIgnoreCase(ATTR_REVOKED_CERTS)) {
-            mRevokedCerts = (Hashtable) obj;
+            mRevokedCerts = (Hashtable<BigInteger, RevokedCertificate>) obj;
         } else if (name.equalsIgnoreCase(ATTR_UNREVOKED_CERTS)) {
-            mUnrevokedCerts = (Hashtable) obj;
+            mUnrevokedCerts = (Hashtable<BigInteger, RevokedCertificate>) obj;
         } else if (name.equalsIgnoreCase(ATTR_EXPIRED_CERTS)) {
-            mExpiredCerts = (Hashtable) obj;
+            mExpiredCerts = (Hashtable<BigInteger, RevokedCertificate>) obj;
         } else if (name.equalsIgnoreCase(ATTR_DELTA_CRL)) {
             mDeltaCRL = (byte[]) obj;
         } else {
@@ -279,47 +284,51 @@ public class CRLIssuingPointRecord implements ICRLIssuingPointRecord, IDBObj {
         return mCACert;
     }
 
-    public Hashtable getCRLCacheNoClone() {
+    public Hashtable<BigInteger, RevokedCertificate> getCRLCacheNoClone() {
         if (mCRLCache == null)
             return null;
         else
-            return (Hashtable) mCRLCache;
+            return mCRLCache;
     }
 
-    public Hashtable getCRLCache() {
+    @SuppressWarnings("unchecked")
+    public Hashtable<BigInteger, RevokedCertificate> getCRLCache() {
         if (mCRLCache == null)
             return null;
         else
-            return (Hashtable) mCRLCache.clone();
+            return (Hashtable<BigInteger, RevokedCertificate>) mCRLCache.clone();
     }
 
     /**
      * Retrieves cache info of revoked certificates.
      */
-    public Hashtable getRevokedCerts() {
+    @SuppressWarnings("unchecked")
+    public Hashtable<BigInteger, RevokedCertificate> getRevokedCerts() {
         if (mRevokedCerts == null)
             return null;
         else
-            return (Hashtable) mRevokedCerts.clone();
+            return (Hashtable<BigInteger, RevokedCertificate>) mRevokedCerts.clone();
     }
 
     /**
      * Retrieves cache info of unrevoked certificates.
      */
-    public Hashtable getUnrevokedCerts() {
+    @SuppressWarnings("unchecked")
+    public Hashtable<BigInteger, RevokedCertificate> getUnrevokedCerts() {
         if (mUnrevokedCerts == null)
             return null;
         else
-            return (Hashtable) mUnrevokedCerts.clone();
+            return (Hashtable<BigInteger, RevokedCertificate>) mUnrevokedCerts.clone();
     }
 
     /**
      * Retrieves cache info of expired certificates.
      */
-    public Hashtable getExpiredCerts() {
+    @SuppressWarnings("unchecked")
+    public Hashtable<BigInteger, RevokedCertificate> getExpiredCerts() {
         if (mExpiredCerts == null)
             return null;
         else
-            return (Hashtable) mExpiredCerts.clone();
+            return (Hashtable<BigInteger, RevokedCertificate>) mExpiredCerts.clone();
     }
 }
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/CRLRepository.java b/pki/base/common/src/com/netscape/cmscore/dbs/CRLRepository.java
index a54ff500f4808847dedc199d10bcf2b71ec381fa..f9c4369a29236168f053304cb74fcbfe1f28f0cb 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/CRLRepository.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/CRLRepository.java
@@ -22,6 +22,8 @@ import java.util.Date;
 import java.util.Hashtable;
 import java.util.Vector;
 
+import netscape.security.x509.RevokedCertificate;
+
 import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.EBaseException;
 import com.netscape.certsrv.dbs.EDBException;
@@ -230,7 +232,9 @@ public class CRLRepository extends Repository implements ICRLRepository {
      */
     public void updateCRLIssuingPointRecord(String id, byte[] newCRL,
             Date thisUpdate, Date nextUpdate, BigInteger crlNumber, Long crlSize,
-            Hashtable revokedCerts, Hashtable unrevokedCerts, Hashtable expiredCerts)
+            Hashtable<BigInteger, RevokedCertificate> revokedCerts,
+            Hashtable<BigInteger, RevokedCertificate> unrevokedCerts,
+            Hashtable<BigInteger, RevokedCertificate> expiredCerts)
             throws EBaseException {
         ModificationSet mods = new ModificationSet();
 
@@ -270,8 +274,9 @@ public class CRLRepository extends Repository implements ICRLRepository {
     /**
      * Updates CRL issuing point record with recently revoked certificates info.
      */
-    public void updateRevokedCerts(String id, Hashtable revokedCerts,
-            Hashtable unrevokedCerts)
+    public void updateRevokedCerts(String id,
+            Hashtable<BigInteger, RevokedCertificate> revokedCerts,
+            Hashtable<BigInteger, RevokedCertificate> unrevokedCerts)
             throws EBaseException {
         ModificationSet mods = new ModificationSet();
 
@@ -287,7 +292,7 @@ public class CRLRepository extends Repository implements ICRLRepository {
     /**
      * Updates CRL issuing point record with recently expired certificates info.
      */
-    public void updateExpiredCerts(String id, Hashtable expiredCerts)
+    public void updateExpiredCerts(String id, Hashtable<BigInteger, RevokedCertificate> expiredCerts)
             throws EBaseException {
         ModificationSet mods = new ModificationSet();
 
@@ -300,9 +305,9 @@ public class CRLRepository extends Repository implements ICRLRepository {
      * Updates CRL issuing point record with CRL cache info.
      */
     public void updateCRLCache(String id, Long crlSize,
-            Hashtable revokedCerts,
-            Hashtable unrevokedCerts,
-            Hashtable expiredCerts)
+            Hashtable<BigInteger, RevokedCertificate> revokedCerts,
+            Hashtable<BigInteger, RevokedCertificate> unrevokedCerts,
+            Hashtable<BigInteger, RevokedCertificate> expiredCerts)
             throws EBaseException {
         ModificationSet mods = new ModificationSet();
 
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/CertificateRepository.java b/pki/base/common/src/com/netscape/cmscore/dbs/CertificateRepository.java
index 8b29dec532e5d7bd1e6e91c2c6dbe1e1f6d76180..6ae37984057f41123f81fb49a2e6cd6fd8f4e8a2 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/CertificateRepository.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/CertificateRepository.java
@@ -45,6 +45,7 @@ import com.netscape.certsrv.ca.ICRLIssuingPoint;
 import com.netscape.certsrv.dbs.EDBException;
 import com.netscape.certsrv.dbs.IDBRegistry;
 import com.netscape.certsrv.dbs.IDBSSession;
+import com.netscape.certsrv.dbs.IDBSearchResults;
 import com.netscape.certsrv.dbs.IDBSubsystem;
 import com.netscape.certsrv.dbs.IDBVirtualList;
 import com.netscape.certsrv.dbs.Modification;
@@ -450,9 +451,6 @@ public class CertificateRepository extends Repository
             }
         }
 
-        CertRecord cRec = null;
-        BigInteger serial = null;
-
         transitCertList(cList, CertRecord.STATUS_EXPIRED);
     }
 
@@ -622,7 +620,6 @@ public class CertificateRepository extends Repository
      */
     public X509CertImpl getX509Certificate(BigInteger serialNo)
             throws EBaseException {
-        X509CertImpl cert = null;
         ICertRecord cr = readCertificateRecord(serialNo);
 
         return (cr.getCertificate());
@@ -767,19 +764,22 @@ public class CertificateRepository extends Repository
         return e;
     }
 
-    public Enumeration<Object> searchCertificates(String filter, int maxSize, int timeLimit)
+    public Enumeration<ICertRecord> searchCertificates(String filter, int maxSize, int timeLimit)
             throws EBaseException {
         IDBSSession s = mDBService.createSession();
-        Enumeration<Object> e = null;
+        Vector<ICertRecord> v = new Vector<ICertRecord>();
 
         CMS.debug("searchCertificateswith time limit filter " + filter);
         try {
-            e = s.search(getDN(), filter, maxSize, timeLimit);
+            IDBSearchResults sr = s.search(getDN(), filter, maxSize, timeLimit);
+            while (sr.hasMoreElements()) {
+                v.add((ICertRecord) sr.nextElement());
+            }
         } finally {
             if (s != null)
                 s.close();
         }
-        return e;
+        return v.elements();
     }
 
     /**
@@ -894,7 +894,7 @@ public class CertificateRepository extends Repository
         CertRecordList list = null;
 
         try {
-            IDBVirtualList<ICertRecord> vlist = s.createVirtualList(getDN(), filter, attrs,
+            IDBVirtualList<ICertRecord> vlist = s.<ICertRecord>createVirtualList(getDN(), filter, attrs,
                     sortKey, pageSize);
 
             list = new CertRecordList(vlist);
@@ -1212,7 +1212,7 @@ public class CertificateRepository extends Repository
             String fromVal = "0";
             try {
                 if (from != null) {
-                    int fv = Integer.parseInt(from);
+                    Integer.parseInt(from);
                     fromVal = from;
                 }
             } catch (Exception e1) {
@@ -1515,8 +1515,6 @@ public class CertificateRepository extends Repository
     public ICertRecordList getInvalidCertsByNotBeforeDate(Date date, int pageSize)
             throws EBaseException {
 
-        String now = null;
-
         Date rightNow = CMS.getCurrentDate();
 
         ICertRecordList list = null;
@@ -1555,8 +1553,6 @@ public class CertificateRepository extends Repository
     public ICertRecordList getValidCertsByNotAfterDate(Date date, int pageSize)
             throws EBaseException {
 
-        String now = null;
-
         ICertRecordList list = null;
         IDBSSession s = mDBService.createSession();
 
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/KeyRecordList.java b/pki/base/common/src/com/netscape/cmscore/dbs/KeyRecordList.java
index 34e50c711636c64da6910dccae0aba0a824e3fe4..941b0552d9de19796f679662117146a2cadd3b0f 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/KeyRecordList.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/KeyRecordList.java
@@ -34,12 +34,12 @@ import com.netscape.certsrv.dbs.keydb.IKeyRecordList;
  */
 public class KeyRecordList implements IKeyRecordList {
 
-    private IDBVirtualList<Object> mVlist = null;
+    private IDBVirtualList<IKeyRecord> mVlist = null;
 
     /**
      * Constructs a key list.
      */
-    public KeyRecordList(IDBVirtualList<Object> vlist) {
+    public KeyRecordList(IDBVirtualList<IKeyRecord> vlist) {
         mVlist = vlist;
     }
 
@@ -62,7 +62,7 @@ public class KeyRecordList implements IKeyRecordList {
     }
 
     public IKeyRecord getKeyRecord(int i) {
-        IKeyRecord record = (IKeyRecord) mVlist.getElementAt(i);
+        IKeyRecord record = mVlist.getElementAt(i);
 
         if (record == null)
             return null;
@@ -78,7 +78,7 @@ public class KeyRecordList implements IKeyRecordList {
         Vector<IKeyRecord> entries = new Vector<IKeyRecord>();
 
         for (int i = startidx; i <= endidx; i++) {
-            IKeyRecord element = (IKeyRecord) mVlist.getElementAt(i);
+            IKeyRecord element = mVlist.getElementAt(i);
 
             if (element != null) {
                 entries.addElement(element);
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/KeyRepository.java b/pki/base/common/src/com/netscape/cmscore/dbs/KeyRepository.java
index 269a94c9d312e3e4831a74224d8dc0cea5f4b760..a5b9c48f8bdbf147a0e4969add2848a673e35702 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/KeyRepository.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/KeyRepository.java
@@ -21,6 +21,7 @@ import java.math.BigInteger;
 import java.security.PublicKey;
 import java.util.Date;
 import java.util.Enumeration;
+import java.util.Vector;
 
 import netscape.security.x509.X500Name;
 
@@ -359,32 +360,38 @@ public class KeyRepository extends Repository implements IKeyRepository {
         return result;
     }
 
-    public Enumeration<Object> searchKeys(String filter, int maxSize)
+    public Enumeration<IKeyRecord> searchKeys(String filter, int maxSize)
             throws EBaseException {
         IDBSSession s = mDBService.createSession();
-        Enumeration<Object> e = null;
+        Vector<IKeyRecord> v = new Vector<IKeyRecord>();
 
         try {
-            e = s.search(getDN(), filter, maxSize);
+            IDBSearchResults sr = s.search(getDN(), filter, maxSize);
+            while (sr.hasMoreElements()) {
+                v.add((IKeyRecord) sr.nextElement());
+            }
         } finally {
             if (s != null)
                 s.close();
         }
-        return e;
+        return v.elements();
     }
 
-    public Enumeration<Object> searchKeys(String filter, int maxSize, int timeLimit)
+    public Enumeration<IKeyRecord> searchKeys(String filter, int maxSize, int timeLimit)
             throws EBaseException {
         IDBSSession s = mDBService.createSession();
-        Enumeration<Object> e = null;
+        Vector<IKeyRecord> v = new Vector<IKeyRecord>();
 
         try {
-            e = s.search(getDN(), filter, maxSize, timeLimit);
+            IDBSearchResults sr = s.search(getDN(), filter, maxSize, timeLimit);
+            while (sr.hasMoreElements()) {
+                v.add((IKeyRecord) sr.nextElement());
+            }
         } finally {
             if (s != null)
                 s.close();
         }
-        return e;
+        return v.elements();
     }
 
     /**
@@ -405,7 +412,7 @@ public class KeyRepository extends Repository implements IKeyRepository {
         try {
             if (s != null) {
                 list = new KeyRecordList(
-                        s.createVirtualList(getDN(), "(&(objectclass=" +
+                        s.<IKeyRecord>createVirtualList(getDN(), "(&(objectclass=" +
                                 KeyRecord.class.getName() + ")" + filter + ")",
                                 attrs, sortKey, pageSize));
             }
@@ -435,7 +442,7 @@ public class KeyRepository extends Repository implements IKeyRepository {
         try {
             if (s != null) {
                 list = new KeyRecordList(
-                        s.createVirtualList(getDN(), "(&(objectclass=" +
+                        s.<IKeyRecord>createVirtualList(getDN(), "(&(objectclass=" +
                                 KeyRecord.class.getName() + ")" + filter + ")",
                                 attrs, jumpToVal, sortKey, pageSize));
             }
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/LdapFilterConverter.java b/pki/base/common/src/com/netscape/cmscore/dbs/LdapFilterConverter.java
index 74ac7ca9673ee024937425f8d061fbee23554f0a..ff867bf52edbff986fa65695bead89f826f2f4fe 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/LdapFilterConverter.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/LdapFilterConverter.java
@@ -34,12 +34,12 @@ import com.netscape.certsrv.dbs.IFilterConverter;
  */
 public class LdapFilterConverter implements IFilterConverter {
 
-    private Hashtable mReg = null;
+    private Hashtable<String, IDBAttrMapper> mReg = null;
 
     /**
      * Constructs filter convertor.
      */
-    public LdapFilterConverter(Hashtable reg) {
+    public LdapFilterConverter(Hashtable<String, IDBAttrMapper> reg) {
         mReg = reg;
     }
 
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/PublicKeyMapper.java b/pki/base/common/src/com/netscape/cmscore/dbs/PublicKeyMapper.java
index f4d8cabeba043eaca86c3972781454a749118ff1..8b66d02cabd0e75597ac7db2bf6ab44499f604f9 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/PublicKeyMapper.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/PublicKeyMapper.java
@@ -44,7 +44,7 @@ import com.netscape.cmscore.cert.CertUtils;
 public class PublicKeyMapper implements IDBAttrMapper {
 
     private String mLdapName = null;
-    private Vector v = new Vector();
+    private Vector<String> v = new Vector<String>();
 
     private ILogger mLogger = CMS.getLogger();
 
@@ -59,7 +59,7 @@ public class PublicKeyMapper implements IDBAttrMapper {
     /**
      * Lists a list of supported ldap attribute names.
      */
-    public Enumeration getSupportedLDAPAttributeNames() {
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
         return v.elements();
     }
 
@@ -95,7 +95,7 @@ public class PublicKeyMapper implements IDBAttrMapper {
         int i = value.indexOf("#");
 
         if (i != -1) {
-            String tag = value.substring(0, i);
+            //String tag = value.substring(0, i);
             String val = value.substring(i + 1);
 
             try {
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/X509CertImplMapper.java b/pki/base/common/src/com/netscape/cmscore/dbs/X509CertImplMapper.java
index 856a8c59193740db53d61aa1ada8e8246a51183b..18f0c8e3d2388174baf02ea1cf42e478f998d007 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/X509CertImplMapper.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/X509CertImplMapper.java
@@ -31,7 +31,6 @@ import netscape.security.extensions.NSCertTypeExtension;
 import netscape.security.x509.BasicConstraintsExtension;
 import netscape.security.x509.Extension;
 import netscape.security.x509.X509CertImpl;
-import netscape.security.x509.X509CertInfo;
 import netscape.security.x509.X509Key;
 
 import com.netscape.certsrv.apps.CMS;
@@ -250,7 +249,6 @@ public class X509CertImplMapper implements IDBAttrMapper {
             //      LDAPAttribute attr = attrs.getAttribute(
             //  	  Schema.LDAP_ATTR_SIGNED_CERT);
 
-            X509CertInfo certinfo = new X509CertInfo();
             LDAPAttribute attr = attrs.getAttribute(
                     CertDBSchema.LDAP_ATTR_SIGNED_CERT);
 
diff --git a/pki/base/common/src/com/netscape/cmscore/ldap/LdapPublishModule.java b/pki/base/common/src/com/netscape/cmscore/ldap/LdapPublishModule.java
index 97297de48f554b83f6a89d80e36c869f4b952aed..bbe86e8a535dfb03bcb93321a404b94925ab29b2 100644
--- a/pki/base/common/src/com/netscape/cmscore/ldap/LdapPublishModule.java
+++ b/pki/base/common/src/com/netscape/cmscore/ldap/LdapPublishModule.java
@@ -43,7 +43,6 @@ import com.netscape.certsrv.dbs.certdb.ICertificateRepository;
 import com.netscape.certsrv.ldap.ELdapException;
 import com.netscape.certsrv.ldap.ILdapConnFactory;
 import com.netscape.certsrv.logging.ILogger;
-import com.netscape.certsrv.publish.ILdapCrlMapper;
 import com.netscape.certsrv.publish.ILdapMapper;
 import com.netscape.certsrv.publish.ILdapPlugin;
 import com.netscape.certsrv.publish.ILdapPublishModule;
@@ -74,13 +73,13 @@ public class LdapPublishModule implements ILdapPublishModule {
      * to publish the crl.
      * When publishers are null, the certs are not published.
      */
-    protected Hashtable mMappers = new Hashtable();
+    protected Hashtable<String, LdapMappers> mMappers = new Hashtable<String, LdapMappers>();
 
     /**
      * handlers for request types (events)
      * values implement IRequestListener
      */
-    protected Hashtable mEventHandlers = new Hashtable();
+    protected Hashtable<String, IRequestListener> mEventHandlers = new Hashtable<String, IRequestListener>();
 
     /**
      * instantiate connection factory.
@@ -274,9 +273,8 @@ public class LdapPublishModule implements ILdapPublishModule {
 
     public void accept(IRequest r) {
         String type = r.getRequestType();
-        boolean error = false;
 
-        IRequestListener handler = (IRequestListener) mEventHandlers.get(type);
+        IRequestListener handler = mEventHandlers.get(type);
 
         if (handler == null) {
             CMS.debug(
@@ -432,8 +430,6 @@ public class LdapPublishModule implements ILdapPublishModule {
      */
     public void publish(X509CRLImpl crl)
             throws ELdapException {
-        ILdapCrlMapper mapper = null;
-        ILdapPublisher publisher = null;
 
         LdapMappers mappers = getMappers(PROP_TYPE_CRL);
 
@@ -575,7 +571,6 @@ class HandleEnrollment implements IRequestListener {
 
         // publish
         Integer results[] = new Integer[certs.length];
-        X509CertImpl cert;
 
         for (int i = 0; i < certs.length; i++) {
             try {
diff --git a/pki/base/common/src/com/netscape/cmscore/ldap/LdapRequestListener.java b/pki/base/common/src/com/netscape/cmscore/ldap/LdapRequestListener.java
index 2f6cadf68de8067a665859fe08c53afaa568adf2..cbeeed2df9e199316bfb9f59238a90b984df96ed 100644
--- a/pki/base/common/src/com/netscape/cmscore/ldap/LdapRequestListener.java
+++ b/pki/base/common/src/com/netscape/cmscore/ldap/LdapRequestListener.java
@@ -48,7 +48,7 @@ public class LdapRequestListener implements IRequestListener {
      * handlers for request types (events)
      * each handler implement IRequestListener
      */
-    private Hashtable mRequestListeners = new Hashtable();
+    private Hashtable<String, IRequestListener> mRequestListeners = new Hashtable<String, IRequestListener>();
 
     private IPublisherProcessor mPublisherProcessor = null;
 
@@ -151,7 +151,7 @@ public class LdapRequestListener implements IRequestListener {
     public void accept(IRequest r) {
         String type = r.getRequestType();
 
-        IRequestListener handler = (IRequestListener) mRequestListeners.get(type);
+        IRequestListener handler = mRequestListeners.get(type);
 
         if (handler == null) {
             CMS.debug(
diff --git a/pki/base/common/src/com/netscape/cmscore/ldapconn/LdapAuthInfo.java b/pki/base/common/src/com/netscape/cmscore/ldapconn/LdapAuthInfo.java
index d2761e791214fd5116d132be56e450d8a215d942..b1af367b9d8ff20e06380b50927f6f753ca0019d 100644
--- a/pki/base/common/src/com/netscape/cmscore/ldapconn/LdapAuthInfo.java
+++ b/pki/base/common/src/com/netscape/cmscore/ldapconn/LdapAuthInfo.java
@@ -38,7 +38,7 @@ public class LdapAuthInfo implements ILdapAuthInfo {
 
     private boolean mInited = false;
 
-    private static Hashtable passwords = new Hashtable();
+    private static Hashtable<String, String> passwords = new Hashtable<String, String>();
 
     /**
      * must call init(config) after this constructor.
@@ -148,7 +148,7 @@ public class LdapAuthInfo implements ILdapAuthInfo {
 
             if (mParms[1] == null) {
                 CMS.debug("LdapAuthInfo: init: try getting from memory cache");
-                mParms[1] = (String) passwords.get(prompt);
+                mParms[1] = passwords.get(prompt);
                 if (mParms[1] != null) {
                     inMem = true;
                     CMS.debug("LdapAuthInfo: init: got password from memory");
diff --git a/pki/base/common/src/com/netscape/cmscore/listeners/ListenerPlugin.java b/pki/base/common/src/com/netscape/cmscore/listeners/ListenerPlugin.java
index 720af4939352047c08661eac84fb822800a0043e..baedb98de137406dc69f029aa00170a0097c533f 100644
--- a/pki/base/common/src/com/netscape/cmscore/listeners/ListenerPlugin.java
+++ b/pki/base/common/src/com/netscape/cmscore/listeners/ListenerPlugin.java
@@ -27,7 +27,7 @@ package com.netscape.cmscore.listeners;
 public class ListenerPlugin {
     protected String mId = null;
     protected String mClassPath = null;
-    protected Class mClass = null;
+    protected Class<?> mClass = null;
 
     /**
      * Constructs a Listener plugin.
diff --git a/pki/base/common/src/com/netscape/cmscore/logging/Logger.java b/pki/base/common/src/com/netscape/cmscore/logging/Logger.java
index 9c814e70cac3f9ac6137f094e0f8dd6138f5d703..79895e263c1df4617277d5a0c4aa0b5706fc62ea 100644
--- a/pki/base/common/src/com/netscape/cmscore/logging/Logger.java
+++ b/pki/base/common/src/com/netscape/cmscore/logging/Logger.java
@@ -38,7 +38,7 @@ public class Logger implements ILogger {
 
     protected static Logger mLogger = new Logger();
     protected ILogQueue mLogQueue = null;
-    protected Hashtable mFactories = new Hashtable();
+    protected Hashtable<Integer, ILogEventFactory> mFactories = new Hashtable<Integer, ILogEventFactory>();
 
     /**
      * Constructs a generic logger, and registers a list
@@ -74,7 +74,7 @@ public class Logger implements ILogger {
      * @param f the event factory name
      */
     public void register(int evtClass, ILogEventFactory f) {
-        mFactories.put(Integer.toString(evtClass), f);
+        mFactories.put(evtClass, f);
     }
 
     //************** default level ****************
@@ -354,8 +354,7 @@ public class Logger implements ILogger {
     //XXXXXXXXXXX prop is out dated!!!! XXXXXXXXXXXXXXX
     public ILogEvent create(int evtClass, Properties prop, int source, int level,
             String msg, Object params[], boolean multiline) {
-        ILogEventFactory f = (ILogEventFactory) mFactories.get(
-                Integer.toString(evtClass));
+        ILogEventFactory f = mFactories.get(evtClass);
 
         if (f == null)
             return null;
diff --git a/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java b/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
index 6a5cb1abcd2625e8d0fe8da66f8bdf155912995c..0e252f523ab1d5f96e114fb9f02cd803a090f607 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
@@ -30,7 +30,6 @@ import java.util.Enumeration;
 import java.util.Hashtable;
 import java.util.Iterator;
 import java.util.Locale;
-import java.util.Map;
 import java.util.Set;
 import java.util.Vector;
 
diff --git a/pki/base/common/src/com/netscape/cmscore/request/RequestQueue.java b/pki/base/common/src/com/netscape/cmscore/request/RequestQueue.java
index e78ff0daf3f8d11affd97576ee32b62b1a04c1ed..b23e6fff4205ac2ab48678fff339ca9d57bc10ba 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/RequestQueue.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/RequestQueue.java
@@ -354,7 +354,7 @@ public class RequestQueue
 
     }
 
-    protected Enumeration getRawList() {
+    protected Enumeration<RequestId> getRawList() {
         IDBSearchResults results = null;
         IDBSSession dbs = null;
 
@@ -517,7 +517,7 @@ public class RequestQueue
     public IRequestVirtualList
             getPagedRequestsByFilter(RequestId from, boolean jumpToEnd, String filter, int pageSize,
                     String sortKey) {
-        IDBVirtualList results = null;
+        IDBVirtualList<Object> results = null;
         IDBSSession dbs = null;
 
         try {
@@ -633,7 +633,7 @@ class SearchEnumeration
         return mResults.hasMoreElements();
     }
 
-    public Object nextElement() {
+    public RequestId nextElement() {
         return nextRequestId();
     }
 
@@ -699,11 +699,11 @@ class ListEnumeration
 
     }
 
-    ListEnumeration(RequestQueue queue, IDBVirtualList list) {
+    ListEnumeration(RequestQueue queue, IDBVirtualList<Object> list) {
         mQueue = queue;
         mList = list;
     }
 
     protected RequestQueue mQueue;
-    protected IDBVirtualList mList;
+    protected IDBVirtualList<Object> mList;
 }
